<?php
/*------------------------------------------------------------------------
# $JA#PRODUCT_NAME$ - Version $JA#VERSION$ - Licence Owner $JA#OWNER$
# ------------------------------------------------------------------------
# Copyright (C) 2004-2008 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
-------------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the JAUC Component
 *
 * @package    jauc
 */
class JaextmanagerViewDefault extends JView {
	var $num;

	function __construct( $config = array()) {
		global $option;
		$this->num = 1;
		parent::__construct( $config );
	}

	function display( $tpl = null ) {
		// Display menu
		if(! JRequest::getVar("ajax") && JRequest::getVar('tmpl') != 'component' && JRequest::getVar('viewmenu', 1) != 0){
			$file = JPATH_COMPONENT_ADMINISTRATOR.DS."views".DS."default".DS."tmpl".DS."menu_header.php";
			if(@file_exists($file))
				require_once($file);
		}
		
		// Get layout
		$layout = $this->getLayout();
		switch ($layout){
			case 'checkupdate':
				$this->displayCheckUpdate( $tpl );
				break;
			case 'diff_view':
				$this->displayDiffView( $tpl );
				break;
			case 'upgrade':
				$this->displayUpgrade( $tpl );
				break;
			case 'recovery':
				$this->displayRecovery($tpl);
				break;
			case 'doRecovery':
				$this->displayDoRecovery($tpl);
				break;
			// Config view layout
			case 'config_general':
				$this->displayConfigGeneral($tpl);
				break;
			case 'config_service':
				$this->displayConfigService($tpl);
				break;
			case 'config_install':
				$this->displayConfigInstall($tpl);
				break;
			case 'config_extension':
				$this->displayConfigExtension($tpl);
				break;
			// Help and support
			case 'help_support':
				$this->displayHelpAndSupport($tpl);
				break;
			// Uploader
			case 'uploader':
				$this->displayUploader($tpl);
				break;
			default:
				$this->displayListItems( $tpl );
		}

		// Display footer
		if(! JRequest::getVar("ajax") && JRequest::getVar('tmpl') != 'component' && JRequest::getVar('viewmenu', 1) != 0){
			$file = JPATH_COMPONENT_ADMINISTRATOR.DS."views".DS."default".DS."tmpl".DS."menu_footer.php";
			if(@file_exists($file))
			require_once($file);
		}
	}

	function displayConfigGeneral($tpl = null){
		JToolBarHelper::save("config_general_save");
		JToolBarHelper::apply("config_general_apply");
		
		// Initialize variables
		$model 	= &$this->getModel('default');		
		$item	= &$this->get('ComponentParams');
		
		$params = new JParameter( $item->params );
				
		$this->assignRef('params', $params);
		
		parent::display( $tpl );
	}
	
	function displayConfigInstall($tpl = null){
		JToolBarHelper::save("save");
		JToolBarHelper::apply("apply");
		parent::display( $tpl );
	}
	
	function displayConfigService($tpl = null){
		JToolBarHelper::save("config_general_save");
		JToolBarHelper::apply("config_general_apply");
		
		// Initialize variables
		$model 	= &$this->getModel('default');		
		
		$this->assignRef('params', $model->getConfigService());
		
		
		parent::display( $tpl );
	}
	
	function displayConfigExtension($tpl = null){
		JToolBarHelper::save("save");
		JToolBarHelper::apply("apply");
		parent::display( $tpl );
	}
	
	function displayHelpAndSupport($tpl = null){
		parent::display( $tpl );
	}

	function loadComponent($component) {
		$component->img    = $component->enabled ? 'tick.png' : 'publish_x.png';
		$component->task   = $component->enabled ? 'disable' : 'enable';
		$component->alt    = $component->enabled ? JText::_( 'Enabled' ) : JText::_( 'Disabled' );
		$component->action = $component->enabled ? JText::_( 'disable' ) : JText::_( 'enable' );

		if ($component->iscore) {
			$component->cbd    = 'disabled';
			$component->style  = 'style="color:#999999;"';
		} else {
			$component->cbd    = null;
			$component->style  = null;
		}
		$component->author_info = @$component->authorEmail .'<br />'. @$component->authorUrl;

		$this->assignRef('component', $component);
	}

	/**
   * Display List of items
   */
	function displayListItems( $tpl = null ) {
		global $mainframe, $option, $jauc;

		/*
		* Set toolbar items for the page
		*/
		JToolBarHelper::apply('checkupdate', JText::_('Check Update'));
		JToolBarHelper::apply('recovery', JText::_('Rollback'));
		// JToolBarHelper::preferences(JACOMPONENT);
		JToolBarHelper::help('screen.jauc');

		$model = &$this->getModel('default');
		
		//$components = &$this->get("components");
		$listExtensions = $model->getListExtensions();
		$state    		= $this->get('State');
		$pagination 	= $model->getPagination();
		
		$boxType = JHTML::_( 'select.genericlist', $model->getListExtensionType(), 'extionsion_type', 'class="inputbox"', 'value', 'text', JRequest::getVar( 'extionsion_type') );

		//$this->assignRef('components',   $components);
		$this->assignRef('listExtensions',  $listExtensions);
		$this->assignRef('pagination',  $pagination);
		$this->assignRef('boxType',  $boxType);

		$this->assignRef('comUri', $this->get("comUri"));

		parent::display( $tpl );
	}

	/**
   * Display Check Upgrade layout
   */
	function displayCheckUpdate( $tpl = null ) {
		global $option;

		// Toolbar
		JToolBarHelper::cancel();

		$model = &$this->getModel('default');
		die($model->getNewVersions());
	}

	/**
   * Display Upgrade layout
   */
	function displayUpgrade( $tpl = null ) {
		global $option;

		// Toolbar
		JToolBarHelper::back();

		$model = &$this->getModel();
		$components = $model->upgradeComponent();
		$pagination = &$this->get('Pagination');

		$this->assignRef('pagination',  $pagination);
		$this->assignRef("components", $components);

		parent::display($tpl);
	}

	function displayRecovery($tpl = null) {
		// Toolbar
		$cIds = JRequest::getVar('cId', array(), '', 'array');
		$cIds = $cIds[0];
		
		$model = &$this->getModel();
		$listRecoveryFiles = &$this->get("ListRecoveryFiles");		
		if($listRecoveryFiles){
			
			$index		= 0;
			$showOnly	= 1;
			$more 		= 0;
			$version	= "";
			
			foreach ($listRecoveryFiles as $file){
				$index++;
				$extID = $file['extID'];
				if ( $file['version'] != $version &&  $version != "" && !$more) {
					$more = 1;
					echo ' [ <a href="#" style="color:#800000" onclick="showMoreOlderVersion(this, \'olderVersion'.$extID.'\'); return false;">'.JText::_("More").'</a> ] ';
					echo '<div id="olderVersion'.$extID.'" style="display:none">';
				}
				
				if($file['version'] != $version){
					$version = $file['version'];
					echo 'Version: '.$version."<br/>";					
				}
				
				echo '
					 &nbsp;&nbsp;&nbsp;|-- 
					 <a href="#" onclick="doRecoveryItem(\''.$cIds.'\', \''.$file['name'].'\'); return false;" title="'.JText::_("Rollback to this point!").'">
						 '.$file['date'].'
					</a>
					'.(isset($file['comment']) ? '['.$file['comment'].']' : '').'
					<br />';
			}
			
			if ( $more ) {
				echo '</div>';
			}
			
		}else {
			echo JText::_("Backup files not found");
		}
		exit();
	}
	
	function displayDoRecovery($tpl = null) {
		// Toolbar
		$cIds = JRequest::getVar('cId', array(), '', 'array');
		$cIds = $cIds[0];
		
		$model = &$this->getModel();
		$action = $model->doRecoveryFile();
		if($action){
			echo "successfully Rollbacked to version: ". substr($action, strpos($action, "_v")+2, strpos($action, "_d") -strpos($action, "_v")-2);
		}else
			echo JText::_("Backup file not found!");
		exit();
	}
	
	function displayUploader($tpl = null) {

		$paths = new stdClass();
		$paths->first = '';

		$this->assignRef('paths', $paths);
		$this->assignRef('state', $this->get('state'));

		parent::display($tpl);
	}
	
	function displayDiffView($tpl = null) {
		global $options;

		// Toolbar
		JToolBarHelper::apply("upgrade", "Upgrade");
		JToolBarHelper::cancel();

		$model = &$this->getModel('default');
		$obj = $model->getDiffView();

		$this->assignRef('obj', $obj);

		parent::display($tpl);
	}
	
	function nicetime($date){
		if(empty($date)) {
			return "No date provided";
		}
	   
		$periods         = array("second", "minute", "hour", "day", "week", "month", "year", "decade");
		$lengths         = array("60","60","24","7","4.35","12","10");
	   
		$now             = time();
		$unix_date       = strtotime($date);
	   
		// check validity of date
		if(empty($unix_date)) {   
			return false;//Bad date
		}
	
		// is it future date or past date
		if($now > $unix_date) {   
			$difference     = $now - $unix_date;
			$tense         = "ago";
		} else {
			$difference     = $unix_date - $now;
			$tense         = "from now";
		}
		
		for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
			$difference /= $lengths[$j];
		}
	   
		$difference = round($difference);
	   
		if($difference != 1) {
			$periods[$j].= "s";
		}
		
		return "$difference $periods[$j] {$tense}";
	}
}
